# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.8
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.




"""Optimization routines."""


from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_optim', [dirname(__file__)])
        except ImportError:
            import _optim
            return _optim
        if fp is not None:
            try:
                _mod = imp.load_module('_optim', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _optim = swig_import_helper()
    del swig_import_helper
else:
    import _optim
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


class SwigPyIterator(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _optim.delete_SwigPyIterator
    __del__ = lambda self: None

    def value(self):
        return _optim.SwigPyIterator_value(self)

    def incr(self, n=1):
        return _optim.SwigPyIterator_incr(self, n)

    def decr(self, n=1):
        return _optim.SwigPyIterator_decr(self, n)

    def distance(self, x):
        return _optim.SwigPyIterator_distance(self, x)

    def equal(self, x):
        return _optim.SwigPyIterator_equal(self, x)

    def copy(self):
        return _optim.SwigPyIterator_copy(self)

    def next(self):
        return _optim.SwigPyIterator_next(self)

    def __next__(self):
        return _optim.SwigPyIterator___next__(self)

    def previous(self):
        return _optim.SwigPyIterator_previous(self)

    def advance(self, n):
        return _optim.SwigPyIterator_advance(self, n)

    def __eq__(self, x):
        return _optim.SwigPyIterator___eq__(self, x)

    def __ne__(self, x):
        return _optim.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n):
        return _optim.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n):
        return _optim.SwigPyIterator___isub__(self, n)

    def __add__(self, n):
        return _optim.SwigPyIterator___add__(self, n)

    def __sub__(self, *args):
        return _optim.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self
SwigPyIterator_swigregister = _optim.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)


_optim.GCC_VERSION_swigconstant(_optim)
GCC_VERSION = _optim.GCC_VERSION

class TestFailed:
    """TestFailed is used to raise an uniform exception in tests."""

    __type = "TestFailed"

    def __init__(self, reason=""):
        self.reason = reason

    def type(self):
        return TestFailed.__type

    def what(self):
        return self.reason

    def __str__(self):
        return TestFailed.__type + ": " + self.reason

    def __lshift__(self, ch):
        self.reason += ch
        return self

import openturns.common
import openturns.typ
import openturns.statistics
import openturns.graph
import openturns.func
import openturns.geom
import openturns.diff
class OptimizationProblemImplementation(openturns.common.PersistentObject):
    """
    Base class to define an optimization problem.

    Available constructors:
        OptimizationProblem()

        OptimizationProblem(*objective, equality, inequality, bounds*)

        OptimizationProblem(*level, value*)

    Parameters
    ----------
    objective : :class:`~openturns.NumericalMathFunction`
        Objective function.
    equality : :class:`~openturns.NumericalMathFunction`
        Equality constraints.
    inequality : :class:`~openturns.NumericalMathFunction`
        Inequality constraints.
    bounds : :class:`~openturns.Interval`
        Bounds.
    level : :class:`~openturns.NumericalMathFunction`
        Level function.
    value : float
        Level value.

    Notes
    -----

    The first form represents a general optimization problem:

    .. math::

        \\min_{x\\in B} f(x) \\\\
        g(x) = 0 \\\\
        h(x) \\ge 0

    where *B* is problem's bounds, *f* is the objective function, *g* are equality constraints, and *h* are inequality constraints.

    The second form represents a nearest point problem:

    .. math::

        \\min_{x} ||x|| \\\\
        g(x) = v

    Examples
    --------

    Define an optimization problem to find the minimum of the Rosenbrock function:

    >>> import openturns as ot
    >>> rosenbrock = ot.NumericalMathFunction(['x1', 'x2'], ['(1-x1)^2+100*(x2-x1^2)^2'])
    >>> problem = ot.OptimizationProblem()
    >>> problem.setObjective(rosenbrock)

    Define an optimization problem to find the point with minimum norm which satisfies :math:`x1+2*x2-3*x3+4*x4=3`.

    >>> import openturns as ot
    >>> levelFunction = ot.NumericalMathFunction(
    ...     ['x1', 'x2', 'x3', 'x4'], ['x1+2*x2-3*x3+4*x4'])
    >>> problem = ot.OptimizationProblem(levelFunction, 3.0)
    """

    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, OptimizationProblemImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, OptimizationProblemImplementation, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.OptimizationProblemImplementation_getClassName(self)


    def getObjective(self):
        """
        Accessor to objective function.

        Returns
        -------
        objective : :class:`~openturns.NumericalMathFunction`
            Objective function.
        """
        return _optim.OptimizationProblemImplementation_getObjective(self)


    def setObjective(self, objective):
        """
        Accessor to objective function.

        Parameters
        ----------
        objectiveFunction : :class:`~openturns.NumericalMathFunction`
            Objective function.
        """
        return _optim.OptimizationProblemImplementation_setObjective(self, objective)


    def hasMultipleObjective(self):
        """
        Test whether objective function is a scalar or vector function.

        Returns
        -------
        value : bool
            *False* if objective function is scalar, *True* otherwise.
        """
        return _optim.OptimizationProblemImplementation_hasMultipleObjective(self)


    def getEqualityConstraint(self):
        """
        Accessor to equality constraints.

        Returns
        -------
        equality : :class:`~openturns.NumericalMathFunction`
            Describe equality constraints.
        """
        return _optim.OptimizationProblemImplementation_getEqualityConstraint(self)


    def setEqualityConstraint(self, equalityConstraint):
        """
        Accessor to equality constraints.

        Parameters
        ----------
        equalityConstraint : :class:`~openturns.NumericalMathFunction`
            Equality constraints.
        """
        return _optim.OptimizationProblemImplementation_setEqualityConstraint(self, equalityConstraint)


    def hasEqualityConstraint(self):
        """
        Test whether equality constraints had been specified.

        Returns
        -------
        value : bool
            *True* if equality constraints had been set for this problem, *False* otherwise.
        """
        return _optim.OptimizationProblemImplementation_hasEqualityConstraint(self)


    def getInequalityConstraint(self):
        """
        Accessor to inequality constraints.

        Returns
        -------
        inequality : :class:`~openturns.NumericalMathFunction`
            Describe inequality constraints.
        """
        return _optim.OptimizationProblemImplementation_getInequalityConstraint(self)


    def setInequalityConstraint(self, inequalityConstraint):
        """
        Accessor to inequality constraints.

        Parameters
        ----------
        inequalityConstraint : :class:`~openturns.NumericalMathFunction`
            Inequality constraints.
        """
        return _optim.OptimizationProblemImplementation_setInequalityConstraint(self, inequalityConstraint)


    def hasInequalityConstraint(self):
        """
        Test whether inequality constraints had been specified.

        Returns
        -------
        value : bool
            *True* if inequality constraints had been set for this problem, *False* otherwise.
        """
        return _optim.OptimizationProblemImplementation_hasInequalityConstraint(self)


    def getBounds(self):
        """
        Accessor to bounds.

        Returns
        -------
        bounds : :class:`~openturns.Interval`
            Problem bounds.
        """
        return _optim.OptimizationProblemImplementation_getBounds(self)


    def setBounds(self, bounds):
        """
        Accessor to bounds.

        Parameters
        ----------
        bounds : :class:`~openturns.Interval`
            Problem bounds.
        """
        return _optim.OptimizationProblemImplementation_setBounds(self, bounds)


    def hasBounds(self):
        """
        Test whether bounds had been specified.

        Returns
        -------
        value : bool
            *True* if bounds had been set for this problem, *False* otherwise.
        """
        return _optim.OptimizationProblemImplementation_hasBounds(self)


    def getLevelFunction(self):
        """
        Accessor to level function.

        Returns
        -------
        level : :class:`~openturns.NumericalMathFunction`
            Level function.
        """
        return _optim.OptimizationProblemImplementation_getLevelFunction(self)


    def setLevelFunction(self, levelFunction):
        """
        Accessor to level function.

        Parameters
        ----------
        levelFunction : :class:`~openturns.NumericalMathFunction`
            Level function.
        """
        return _optim.OptimizationProblemImplementation_setLevelFunction(self, levelFunction)


    def hasLevelFunction(self):
        """
        Test whether level function had been specified.

        Returns
        -------
        value : bool
            *True* if level function had been set for this problem, *False* otherwise.
        """
        return _optim.OptimizationProblemImplementation_hasLevelFunction(self)


    def getLevelValue(self):
        """
        Accessor to level value.

        Returns
        -------
        value : float
            Level value.
        """
        return _optim.OptimizationProblemImplementation_getLevelValue(self)


    def setLevelValue(self, levelValue):
        """
        Accessor to level value.

        Parameters
        ----------
        levelValue : float
            Level value.
        """
        return _optim.OptimizationProblemImplementation_setLevelValue(self, levelValue)


    def getDimension(self):
        """
        Accessor to spatial dimension.

        Returns
        -------
        dimension : int
            Input dimension of objective function.
        """
        return _optim.OptimizationProblemImplementation_getDimension(self)


    def setMinimization(self, minimization):
        """
        Tell whether this is a minimization or maximization problem.

        Parameters
        ----------
        minimization : bool
            *True* if this is a minimization problem, *False* otherwise.
        """
        return _optim.OptimizationProblemImplementation_setMinimization(self, minimization)


    def isMinimization(self):
        """
        Test whether this is a minimization or maximization problem.

        Returns
        -------
        value : bool
            *True* if this is a minimization problem (default), *False* otherwise.
        """
        return _optim.OptimizationProblemImplementation_isMinimization(self)


    def __repr__(self):
        return _optim.OptimizationProblemImplementation___repr__(self)

    def __init__(self, *args):
        this = _optim.new_OptimizationProblemImplementation(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_OptimizationProblemImplementation
    __del__ = lambda self: None
OptimizationProblemImplementation_swigregister = _optim.OptimizationProblemImplementation_swigregister
OptimizationProblemImplementation_swigregister(OptimizationProblemImplementation)

class OptimizationProblemImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, OptimizationProblemImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, OptimizationProblemImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _optim.new_OptimizationProblemImplementationTypedInterfaceObject(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this

    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _optim.OptimizationProblemImplementationTypedInterfaceObject_getImplementation(self, *args)


    def setName(self, name):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _optim.OptimizationProblemImplementationTypedInterfaceObject_setName(self, name)


    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : str
            The name of the object.
        """
        return _optim.OptimizationProblemImplementationTypedInterfaceObject_getName(self)


    def __eq__(self, other):
        return _optim.OptimizationProblemImplementationTypedInterfaceObject___eq__(self, other)
    __swig_destroy__ = _optim.delete_OptimizationProblemImplementationTypedInterfaceObject
    __del__ = lambda self: None
OptimizationProblemImplementationTypedInterfaceObject_swigregister = _optim.OptimizationProblemImplementationTypedInterfaceObject_swigregister
OptimizationProblemImplementationTypedInterfaceObject_swigregister(OptimizationProblemImplementationTypedInterfaceObject)

class OptimizationProblem(OptimizationProblemImplementationTypedInterfaceObject):
    """
    Base class to define an optimization problem.

    Available constructors:
        OptimizationProblem()

        OptimizationProblem(*objective, equality, inequality, bounds*)

        OptimizationProblem(*level, value*)

    Parameters
    ----------
    objective : :class:`~openturns.NumericalMathFunction`
        Objective function.
    equality : :class:`~openturns.NumericalMathFunction`
        Equality constraints.
    inequality : :class:`~openturns.NumericalMathFunction`
        Inequality constraints.
    bounds : :class:`~openturns.Interval`
        Bounds.
    level : :class:`~openturns.NumericalMathFunction`
        Level function.
    value : float
        Level value.

    Notes
    -----

    The first form represents a general optimization problem:

    .. math::

        \\min_{x\\in B} f(x) \\\\
        g(x) = 0 \\\\
        h(x) \\ge 0

    where *B* is problem's bounds, *f* is the objective function, *g* are equality constraints, and *h* are inequality constraints.

    The second form represents a nearest point problem:

    .. math::

        \\min_{x} ||x|| \\\\
        g(x) = v

    Examples
    --------

    Define an optimization problem to find the minimum of the Rosenbrock function:

    >>> import openturns as ot
    >>> rosenbrock = ot.NumericalMathFunction(['x1', 'x2'], ['(1-x1)^2+100*(x2-x1^2)^2'])
    >>> problem = ot.OptimizationProblem()
    >>> problem.setObjective(rosenbrock)

    Define an optimization problem to find the point with minimum norm which satisfies :math:`x1+2*x2-3*x3+4*x4=3`.

    >>> import openturns as ot
    >>> levelFunction = ot.NumericalMathFunction(
    ...     ['x1', 'x2', 'x3', 'x4'], ['x1+2*x2-3*x3+4*x4'])
    >>> problem = ot.OptimizationProblem(levelFunction, 3.0)
    """

    __swig_setmethods__ = {}
    for _s in [OptimizationProblemImplementationTypedInterfaceObject]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, OptimizationProblem, name, value)
    __swig_getmethods__ = {}
    for _s in [OptimizationProblemImplementationTypedInterfaceObject]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, OptimizationProblem, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.OptimizationProblem_getClassName(self)


    def getObjective(self):
        """
        Accessor to objective function.

        Returns
        -------
        objective : :class:`~openturns.NumericalMathFunction`
            Objective function.
        """
        return _optim.OptimizationProblem_getObjective(self)


    def setObjective(self, objective):
        """
        Accessor to objective function.

        Parameters
        ----------
        objectiveFunction : :class:`~openturns.NumericalMathFunction`
            Objective function.
        """
        return _optim.OptimizationProblem_setObjective(self, objective)


    def hasMultipleObjective(self):
        """
        Test whether objective function is a scalar or vector function.

        Returns
        -------
        value : bool
            *False* if objective function is scalar, *True* otherwise.
        """
        return _optim.OptimizationProblem_hasMultipleObjective(self)


    def getEqualityConstraint(self):
        """
        Accessor to equality constraints.

        Returns
        -------
        equality : :class:`~openturns.NumericalMathFunction`
            Describe equality constraints.
        """
        return _optim.OptimizationProblem_getEqualityConstraint(self)


    def setEqualityConstraint(self, equalityConstraint):
        """
        Accessor to equality constraints.

        Parameters
        ----------
        equalityConstraint : :class:`~openturns.NumericalMathFunction`
            Equality constraints.
        """
        return _optim.OptimizationProblem_setEqualityConstraint(self, equalityConstraint)


    def hasEqualityConstraint(self):
        """
        Test whether equality constraints had been specified.

        Returns
        -------
        value : bool
            *True* if equality constraints had been set for this problem, *False* otherwise.
        """
        return _optim.OptimizationProblem_hasEqualityConstraint(self)


    def getInequalityConstraint(self):
        """
        Accessor to inequality constraints.

        Returns
        -------
        inequality : :class:`~openturns.NumericalMathFunction`
            Describe inequality constraints.
        """
        return _optim.OptimizationProblem_getInequalityConstraint(self)


    def setInequalityConstraint(self, inequalityConstraint):
        """
        Accessor to inequality constraints.

        Parameters
        ----------
        inequalityConstraint : :class:`~openturns.NumericalMathFunction`
            Inequality constraints.
        """
        return _optim.OptimizationProblem_setInequalityConstraint(self, inequalityConstraint)


    def hasInequalityConstraint(self):
        """
        Test whether inequality constraints had been specified.

        Returns
        -------
        value : bool
            *True* if inequality constraints had been set for this problem, *False* otherwise.
        """
        return _optim.OptimizationProblem_hasInequalityConstraint(self)


    def getBounds(self):
        """
        Accessor to bounds.

        Returns
        -------
        bounds : :class:`~openturns.Interval`
            Problem bounds.
        """
        return _optim.OptimizationProblem_getBounds(self)


    def setBounds(self, bounds):
        """
        Accessor to bounds.

        Parameters
        ----------
        bounds : :class:`~openturns.Interval`
            Problem bounds.
        """
        return _optim.OptimizationProblem_setBounds(self, bounds)


    def hasBounds(self):
        """
        Test whether bounds had been specified.

        Returns
        -------
        value : bool
            *True* if bounds had been set for this problem, *False* otherwise.
        """
        return _optim.OptimizationProblem_hasBounds(self)


    def getLevelFunction(self):
        """
        Accessor to level function.

        Returns
        -------
        level : :class:`~openturns.NumericalMathFunction`
            Level function.
        """
        return _optim.OptimizationProblem_getLevelFunction(self)


    def setLevelFunction(self, levelFunction):
        """
        Accessor to level function.

        Parameters
        ----------
        levelFunction : :class:`~openturns.NumericalMathFunction`
            Level function.
        """
        return _optim.OptimizationProblem_setLevelFunction(self, levelFunction)


    def hasLevelFunction(self):
        """
        Test whether level function had been specified.

        Returns
        -------
        value : bool
            *True* if level function had been set for this problem, *False* otherwise.
        """
        return _optim.OptimizationProblem_hasLevelFunction(self)


    def getLevelValue(self):
        """
        Accessor to level value.

        Returns
        -------
        value : float
            Level value.
        """
        return _optim.OptimizationProblem_getLevelValue(self)


    def setLevelValue(self, levelValue):
        """
        Accessor to level value.

        Parameters
        ----------
        levelValue : float
            Level value.
        """
        return _optim.OptimizationProblem_setLevelValue(self, levelValue)


    def getDimension(self):
        """
        Accessor to spatial dimension.

        Returns
        -------
        dimension : int
            Input dimension of objective function.
        """
        return _optim.OptimizationProblem_getDimension(self)


    def setMinimization(self, minimization):
        """
        Tell whether this is a minimization or maximization problem.

        Parameters
        ----------
        minimization : bool
            *True* if this is a minimization problem, *False* otherwise.
        """
        return _optim.OptimizationProblem_setMinimization(self, minimization)


    def isMinimization(self):
        """
        Test whether this is a minimization or maximization problem.

        Returns
        -------
        value : bool
            *True* if this is a minimization problem (default), *False* otherwise.
        """
        return _optim.OptimizationProblem_isMinimization(self)


    def __repr__(self):
        return _optim.OptimizationProblem___repr__(self)

    def __str__(self, *args):
        return _optim.OptimizationProblem___str__(self, *args)

    def __init__(self, *args):
        this = _optim.new_OptimizationProblem(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_OptimizationProblem
    __del__ = lambda self: None
OptimizationProblem_swigregister = _optim.OptimizationProblem_swigregister
OptimizationProblem_swigregister(OptimizationProblem)

class OptimizationResult(openturns.common.PersistentObject):
    """
    Optimization result.

    Returned by optimization solvers, see :class:`~openturns.OptimizationSolver`.

    Parameters
    ----------
    optimalPoint : sequence of float
        Optimal point.
    optimalValue : sequence of float
        Value at optimal point.
    iterationNumber : int
        Number of iterations.
    absoluteError : float
        Parameters for this solver.
    relativeError : float
        Relative error.
    residualError : float
        Residual error.
    constraintError : float
        Constraint error.
    """

    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, OptimizationResult, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, OptimizationResult, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.OptimizationResult_getClassName(self)


    def getOptimalPoint(self):
        """
        Accessor to the optimal point.

        Returns
        -------
        optimalPoint : :class:`~openturns.NumericalPoint`
             Optimal point
        """
        return _optim.OptimizationResult_getOptimalPoint(self)


    def getOptimalValue(self):
        """
        Accessor to the optimal value.

        Returns
        -------
        optimalValue : :class:`~openturns.NumericalPoint`
             Value at the optimal point
        """
        return _optim.OptimizationResult_getOptimalValue(self)


    def getIterationNumber(self):
        """
        Accessor to the number of iterations.

        Returns
        -------
        iterationNumber : int
             Number of evaluations.
        """
        return _optim.OptimizationResult_getIterationNumber(self)


    def getAbsoluteError(self):
        """
        Accessor to the absolute error.

        Returns
        -------
        absoluteError : float
             absolute error.
        """
        return _optim.OptimizationResult_getAbsoluteError(self)


    def getAbsoluteErrorHistory(self):
        return _optim.OptimizationResult_getAbsoluteErrorHistory(self)

    def getRelativeError(self):
        """
        Accessor to the relative error.

        Returns
        -------
        relativeError : float
             allowed relative error.
        """
        return _optim.OptimizationResult_getRelativeError(self)


    def getRelativeErrorHistory(self):
        return _optim.OptimizationResult_getRelativeErrorHistory(self)

    def getResidualError(self):
        """
        Accessor to the residual error.

        Returns
        -------
        residualError : float
             allowed residual error.
        """
        return _optim.OptimizationResult_getResidualError(self)


    def getResidualErrorHistory(self):
        return _optim.OptimizationResult_getResidualErrorHistory(self)

    def getConstraintError(self):
        """
        Accessor to the constraint error.

        Returns
        -------
        constraintError : float
             Constraint error.
        """
        return _optim.OptimizationResult_getConstraintError(self)


    def getConstraintErrorHistory(self):
        return _optim.OptimizationResult_getConstraintErrorHistory(self)

    def getInputSample(self):
        """
        Accessor to the input sample.

        Returns
        -------
        inputSample : :class:`~openturns.NumericalSample`
             Input points used by the solver
        """
        return _optim.OptimizationResult_getInputSample(self)


    def getOutputSample(self):
        """
        Accessor to the output sample.

        Returns
        -------
        outputSample : :class:`~openturns.NumericalSample`
             Output points used by the solver
        """
        return _optim.OptimizationResult_getOutputSample(self)


    def __repr__(self):
        return _optim.OptimizationResult___repr__(self)

    def update(self, optimalPoint, iterationNumber):
        return _optim.OptimizationResult_update(self, optimalPoint, iterationNumber)

    def store(self, inP, outP, absoluteError, relativeError, residualError, constraintError):
        return _optim.OptimizationResult_store(self, inP, outP, absoluteError, relativeError, residualError, constraintError)

    def drawErrorHistory(self):
        """
        Draw the convergence criteria history.

        Returns
        -------
        graph : :class:`~openturns.Graph`
             Convergence criteria history graph
        """
        return _optim.OptimizationResult_drawErrorHistory(self)


    def __init__(self, *args):
        this = _optim.new_OptimizationResult(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_OptimizationResult
    __del__ = lambda self: None
OptimizationResult_swigregister = _optim.OptimizationResult_swigregister
OptimizationResult_swigregister(OptimizationResult)

class OptimizationSolverImplementation(openturns.common.PersistentObject):
    """
    Base class for optimization wrappers.

    Available constructors:
        OptimizationSolver(*problem, verbose=False*)

    Parameters
    ----------
    problem : :class:`~openturns.OptimizationProblem`
        Optimization problem.
    verbose : bool
        Let solver be more verbose.

    Notes
    -----

    Class :class:`~openturns.OptimizationSolver` is an abstract class, which has several implementations.
    The default implementation is :class:`~openturns.Cobyla`, but there are also
    :class:`~openturns.AbdoRackwitz`, :class:`~openturns.SQP` and :class:`~openturns.TNC`.

    Examples
    --------

    Define an optimization problem to find the minimum of the Rosenbrock function:

    >>> import openturns as ot
    >>> rosenbrock = ot.NumericalMathFunction(['x1', 'x2'], ['(1-x1)^2+100*(x2-x1^2)^2'])
    >>> problem = ot.OptimizationProblem()
    >>> problem.setObjective(rosenbrock)
    >>> solver = ot.OptimizationSolver(problem)
    >>> solver.setStartingPoint([0, 0])
    >>> solver.setMaximumResidualError(1.e-8)
    >>> solver.setMaximumIterationNumber(100000)
    >>> solver.run()
    >>> result = solver.getResult()
    """

    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, OptimizationSolverImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, OptimizationSolverImplementation, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.OptimizationSolverImplementation_getClassName(self)


    def run(self):
        """Launch the optimization."""
        return _optim.OptimizationSolverImplementation_run(self)


    def getStartingPoint(self):
        """
        Accessor to starting point.

        Returns
        -------
        startingPoint : :class:`~openturns.NumericalPoint`
            Starting point.
        """
        return _optim.OptimizationSolverImplementation_getStartingPoint(self)


    def setStartingPoint(self, startingPoint):
        """
        Accessor to starting point.

        Parameters
        ----------
        startingPoint : :class:`~openturns.NumericalPoint`
            Starting point.
        """
        return _optim.OptimizationSolverImplementation_setStartingPoint(self, startingPoint)


    def getProblem(self):
        """
        Accessor to optimization problem.

        Returns
        -------
        problem : :class:`~openturns.OptimizationProblem`
            Optimization problem.
        """
        return _optim.OptimizationSolverImplementation_getProblem(self)


    def setProblem(self, problem):
        """
        Accessor to optimization problem.

        Parameters
        ----------
        problem : :class:`~openturns.OptimizationProblem`
            Optimization problem.
        """
        return _optim.OptimizationSolverImplementation_setProblem(self, problem)


    def getResult(self):
        """
        Accessor to optimization result.

        Returns
        -------
        result : :class:`~openturns.OptimizationResult`
            Result class.
        """
        return _optim.OptimizationSolverImplementation_getResult(self)


    def setResult(self, result):
        """
        Accessor to optimization result.

        Parameters
        ----------
        result : :class:`~openturns.OptimizationResult`
            Result class.
        """
        return _optim.OptimizationSolverImplementation_setResult(self, result)


    def setMaximumIterationNumber(self, maximumIterationNumber):
        """
        Accessor to maximum allowed number of iterations.

        Parameters
        ----------
        N : int
            Maximum allowed number of iterations.
        """
        return _optim.OptimizationSolverImplementation_setMaximumIterationNumber(self, maximumIterationNumber)


    def getMaximumIterationNumber(self):
        """
        Accessor to maximum allowed number of iterations.

        Returns
        -------
        N : int
            Maximum allowed number of iterations.
        """
        return _optim.OptimizationSolverImplementation_getMaximumIterationNumber(self)


    def setMaximumIterationsNumber(self, maximumIterationsNumber):
        return _optim.OptimizationSolverImplementation_setMaximumIterationsNumber(self, maximumIterationsNumber)

    def getMaximumIterationsNumber(self):
        return _optim.OptimizationSolverImplementation_getMaximumIterationsNumber(self)

    def setMaximumEvaluationNumber(self, maximumEvaluationNumber):
        """
        Accessor to maximum allowed number of evaluations.

        Parameters
        ----------
        N : int
            Maximum allowed number of evaluations.
        """
        return _optim.OptimizationSolverImplementation_setMaximumEvaluationNumber(self, maximumEvaluationNumber)


    def getMaximumEvaluationNumber(self):
        """
        Accessor to maximum allowed number of evaluations.

        Returns
        -------
        N : int
            Maximum allowed number of evaluations.
        """
        return _optim.OptimizationSolverImplementation_getMaximumEvaluationNumber(self)


    def getMaximumAbsoluteError(self):
        """
        Accessor to maximum allowed absolute error.

        Returns
        -------
        maximumAbsoluteError : float
            Maximum allowed absolute error.
        """
        return _optim.OptimizationSolverImplementation_getMaximumAbsoluteError(self)


    def setMaximumAbsoluteError(self, maximumAbsoluteError):
        """
        Accessor to maximum allowed absolute error.

        Parameters
        ----------
        maximumAbsoluteError : float
            Maximum allowed absolute error.
        """
        return _optim.OptimizationSolverImplementation_setMaximumAbsoluteError(self, maximumAbsoluteError)


    def getMaximumRelativeError(self):
        """
        Accessor to maximum allowed relative error.

        Returns
        -------
        maximumRelativeError : float
            Maximum allowed relative error.
        """
        return _optim.OptimizationSolverImplementation_getMaximumRelativeError(self)


    def setMaximumRelativeError(self, maximumRelativeError):
        """
        Accessor to maximum allowed relative error.

        Parameters
        ----------
        maximumRelativeError : float
            Maximum allowed relative error.
        """
        return _optim.OptimizationSolverImplementation_setMaximumRelativeError(self, maximumRelativeError)


    def getMaximumResidualError(self):
        """
        Accessor to maximum allowed residual error.

        Returns
        -------
        maximumResidualError : float
            Maximum allowed residual error.
        """
        return _optim.OptimizationSolverImplementation_getMaximumResidualError(self)


    def setMaximumResidualError(self, maximumResidualError):
        """
        Accessor to maximum allowed residual error.

        Parameters
        ----------
        maximumResidualError : float
            Maximum allowed residual error.
        """
        return _optim.OptimizationSolverImplementation_setMaximumResidualError(self, maximumResidualError)


    def getMaximumConstraintError(self):
        """
        Accessor to maximum allowed constraint error.

        Returns
        -------
        maximumConstraintError : float
            Maximum allowed constraint error.
        """
        return _optim.OptimizationSolverImplementation_getMaximumConstraintError(self)


    def setMaximumConstraintError(self, maximumConstraintError):
        """
        Accessor to maximum allowed constraint error.

        Parameters
        ----------
        maximumConstraintError : float
            Maximum allowed constraint error.
        """
        return _optim.OptimizationSolverImplementation_setMaximumConstraintError(self, maximumConstraintError)


    def __repr__(self):
        return _optim.OptimizationSolverImplementation___repr__(self)

    def getVerbose(self):
        """
        Accessor to the verbosity flag.

        Returns
        ----------
        verbose : bool
            Verbosity flag state.
        """
        return _optim.OptimizationSolverImplementation_getVerbose(self)


    def setVerbose(self, verbose):
        """
        Accessor to the verbosity flag.

        Parameters
        ----------
        verbose : bool
            Verbosity flag state.
        """
        return _optim.OptimizationSolverImplementation_setVerbose(self, verbose)


    def __init__(self, *args):
        this = _optim.new_OptimizationSolverImplementation(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_OptimizationSolverImplementation
    __del__ = lambda self: None
OptimizationSolverImplementation_swigregister = _optim.OptimizationSolverImplementation_swigregister
OptimizationSolverImplementation_swigregister(OptimizationSolverImplementation)

class OptimizationSolverImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, OptimizationSolverImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, OptimizationSolverImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _optim.new_OptimizationSolverImplementationTypedInterfaceObject(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this

    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _optim.OptimizationSolverImplementationTypedInterfaceObject_getImplementation(self, *args)


    def setName(self, name):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _optim.OptimizationSolverImplementationTypedInterfaceObject_setName(self, name)


    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : str
            The name of the object.
        """
        return _optim.OptimizationSolverImplementationTypedInterfaceObject_getName(self)


    def __eq__(self, other):
        return _optim.OptimizationSolverImplementationTypedInterfaceObject___eq__(self, other)
    __swig_destroy__ = _optim.delete_OptimizationSolverImplementationTypedInterfaceObject
    __del__ = lambda self: None
OptimizationSolverImplementationTypedInterfaceObject_swigregister = _optim.OptimizationSolverImplementationTypedInterfaceObject_swigregister
OptimizationSolverImplementationTypedInterfaceObject_swigregister(OptimizationSolverImplementationTypedInterfaceObject)

class OptimizationSolver(OptimizationSolverImplementationTypedInterfaceObject):
    """
    Base class for optimization wrappers.

    Available constructors:
        OptimizationSolver(*problem, verbose=False*)

    Parameters
    ----------
    problem : :class:`~openturns.OptimizationProblem`
        Optimization problem.
    verbose : bool
        Let solver be more verbose.

    Notes
    -----

    Class :class:`~openturns.OptimizationSolver` is an abstract class, which has several implementations.
    The default implementation is :class:`~openturns.Cobyla`, but there are also
    :class:`~openturns.AbdoRackwitz`, :class:`~openturns.SQP` and :class:`~openturns.TNC`.

    Examples
    --------

    Define an optimization problem to find the minimum of the Rosenbrock function:

    >>> import openturns as ot
    >>> rosenbrock = ot.NumericalMathFunction(['x1', 'x2'], ['(1-x1)^2+100*(x2-x1^2)^2'])
    >>> problem = ot.OptimizationProblem()
    >>> problem.setObjective(rosenbrock)
    >>> solver = ot.OptimizationSolver(problem)
    >>> solver.setStartingPoint([0, 0])
    >>> solver.setMaximumResidualError(1.e-8)
    >>> solver.setMaximumIterationNumber(100000)
    >>> solver.run()
    >>> result = solver.getResult()
    """

    __swig_setmethods__ = {}
    for _s in [OptimizationSolverImplementationTypedInterfaceObject]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, OptimizationSolver, name, value)
    __swig_getmethods__ = {}
    for _s in [OptimizationSolverImplementationTypedInterfaceObject]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, OptimizationSolver, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.OptimizationSolver_getClassName(self)


    def run(self):
        """Launch the optimization."""
        return _optim.OptimizationSolver_run(self)


    def getStartingPoint(self):
        """
        Accessor to starting point.

        Returns
        -------
        startingPoint : :class:`~openturns.NumericalPoint`
            Starting point.
        """
        return _optim.OptimizationSolver_getStartingPoint(self)


    def setStartingPoint(self, startingPoint):
        """
        Accessor to starting point.

        Parameters
        ----------
        startingPoint : :class:`~openturns.NumericalPoint`
            Starting point.
        """
        return _optim.OptimizationSolver_setStartingPoint(self, startingPoint)


    def getProblem(self):
        """
        Accessor to optimization problem.

        Returns
        -------
        problem : :class:`~openturns.OptimizationProblem`
            Optimization problem.
        """
        return _optim.OptimizationSolver_getProblem(self)


    def setProblem(self, problem):
        """
        Accessor to optimization problem.

        Parameters
        ----------
        problem : :class:`~openturns.OptimizationProblem`
            Optimization problem.
        """
        return _optim.OptimizationSolver_setProblem(self, problem)


    def getResult(self):
        """
        Accessor to optimization result.

        Returns
        -------
        result : :class:`~openturns.OptimizationResult`
            Result class.
        """
        return _optim.OptimizationSolver_getResult(self)


    def setResult(self, result):
        """
        Accessor to optimization result.

        Parameters
        ----------
        result : :class:`~openturns.OptimizationResult`
            Result class.
        """
        return _optim.OptimizationSolver_setResult(self, result)


    def getMaximumIterationNumber(self):
        """
        Accessor to maximum allowed number of iterations.

        Returns
        -------
        N : int
            Maximum allowed number of iterations.
        """
        return _optim.OptimizationSolver_getMaximumIterationNumber(self)


    def setMaximumIterationNumber(self, maximumIterationNumber):
        """
        Accessor to maximum allowed number of iterations.

        Parameters
        ----------
        N : int
            Maximum allowed number of iterations.
        """
        return _optim.OptimizationSolver_setMaximumIterationNumber(self, maximumIterationNumber)


    def getMaximumIterationsNumber(self):
        return _optim.OptimizationSolver_getMaximumIterationsNumber(self)

    def setMaximumIterationsNumber(self, maximumIterationsNumber):
        return _optim.OptimizationSolver_setMaximumIterationsNumber(self, maximumIterationsNumber)

    def getMaximumAbsoluteError(self):
        """
        Accessor to maximum allowed absolute error.

        Returns
        -------
        maximumAbsoluteError : float
            Maximum allowed absolute error.
        """
        return _optim.OptimizationSolver_getMaximumAbsoluteError(self)


    def setMaximumAbsoluteError(self, maximumAbsoluteError):
        """
        Accessor to maximum allowed absolute error.

        Parameters
        ----------
        maximumAbsoluteError : float
            Maximum allowed absolute error.
        """
        return _optim.OptimizationSolver_setMaximumAbsoluteError(self, maximumAbsoluteError)


    def getMaximumRelativeError(self):
        """
        Accessor to maximum allowed relative error.

        Returns
        -------
        maximumRelativeError : float
            Maximum allowed relative error.
        """
        return _optim.OptimizationSolver_getMaximumRelativeError(self)


    def setMaximumRelativeError(self, maximumRelativeError):
        """
        Accessor to maximum allowed relative error.

        Parameters
        ----------
        maximumRelativeError : float
            Maximum allowed relative error.
        """
        return _optim.OptimizationSolver_setMaximumRelativeError(self, maximumRelativeError)


    def getMaximumResidualError(self):
        """
        Accessor to maximum allowed residual error.

        Returns
        -------
        maximumResidualError : float
            Maximum allowed residual error.
        """
        return _optim.OptimizationSolver_getMaximumResidualError(self)


    def setMaximumResidualError(self, maximumResidualError):
        """
        Accessor to maximum allowed residual error.

        Parameters
        ----------
        maximumResidualError : float
            Maximum allowed residual error.
        """
        return _optim.OptimizationSolver_setMaximumResidualError(self, maximumResidualError)


    def getMaximumConstraintError(self):
        """
        Accessor to maximum allowed constraint error.

        Returns
        -------
        maximumConstraintError : float
            Maximum allowed constraint error.
        """
        return _optim.OptimizationSolver_getMaximumConstraintError(self)


    def setMaximumConstraintError(self, maximumConstraintError):
        """
        Accessor to maximum allowed constraint error.

        Parameters
        ----------
        maximumConstraintError : float
            Maximum allowed constraint error.
        """
        return _optim.OptimizationSolver_setMaximumConstraintError(self, maximumConstraintError)


    def getVerbose(self):
        """
        Accessor to the verbosity flag.

        Returns
        ----------
        verbose : bool
            Verbosity flag state.
        """
        return _optim.OptimizationSolver_getVerbose(self)


    def setVerbose(self, verbose):
        """
        Accessor to the verbosity flag.

        Parameters
        ----------
        verbose : bool
            Verbosity flag state.
        """
        return _optim.OptimizationSolver_setVerbose(self, verbose)


    def __repr__(self):
        return _optim.OptimizationSolver___repr__(self)

    def __str__(self, *args):
        return _optim.OptimizationSolver___str__(self, *args)

    def __init__(self, *args):
        this = _optim.new_OptimizationSolver(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_OptimizationSolver
    __del__ = lambda self: None
OptimizationSolver_swigregister = _optim.OptimizationSolver_swigregister
OptimizationSolver_swigregister(OptimizationSolver)

class NearestPointCheckerResult(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NearestPointCheckerResult, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, NearestPointCheckerResult, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.NearestPointCheckerResult_getClassName(self)


    def getVerifyingConstraintPoints(self):
        return _optim.NearestPointCheckerResult_getVerifyingConstraintPoints(self)

    def getVerifyingConstraintValues(self):
        return _optim.NearestPointCheckerResult_getVerifyingConstraintValues(self)

    def getViolatingConstraintPoints(self):
        return _optim.NearestPointCheckerResult_getViolatingConstraintPoints(self)

    def getViolatingConstraintValues(self):
        return _optim.NearestPointCheckerResult_getViolatingConstraintValues(self)

    def setVerifyingConstraintPoints(self, verifyingConstraintPoints):
        return _optim.NearestPointCheckerResult_setVerifyingConstraintPoints(self, verifyingConstraintPoints)

    def setVerifyingConstraintValues(self, verifyingConstraintValues):
        return _optim.NearestPointCheckerResult_setVerifyingConstraintValues(self, verifyingConstraintValues)

    def setViolatingConstraintPoints(self, violatingConstraintPoints):
        return _optim.NearestPointCheckerResult_setViolatingConstraintPoints(self, violatingConstraintPoints)

    def setViolatingConstraintValues(self, violatingConstraintValues):
        return _optim.NearestPointCheckerResult_setViolatingConstraintValues(self, violatingConstraintValues)

    def __repr__(self):
        return _optim.NearestPointCheckerResult___repr__(self)

    def __init__(self, *args):
        this = _optim.new_NearestPointCheckerResult(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_NearestPointCheckerResult
    __del__ = lambda self: None
NearestPointCheckerResult_swigregister = _optim.NearestPointCheckerResult_swigregister
NearestPointCheckerResult_swigregister(NearestPointCheckerResult)

class NearestPointChecker(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NearestPointChecker, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, NearestPointChecker, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.NearestPointChecker_getClassName(self)


    def setLevelFunction(self, levelFunction):
        return _optim.NearestPointChecker_setLevelFunction(self, levelFunction)

    def getLevelFunction(self):
        return _optim.NearestPointChecker_getLevelFunction(self)

    def setResult(self, result):
        return _optim.NearestPointChecker_setResult(self, result)

    def getResult(self):
        return _optim.NearestPointChecker_getResult(self)

    def setComparisonOperator(self, comparisonOperator):
        return _optim.NearestPointChecker_setComparisonOperator(self, comparisonOperator)

    def getComparisonOperator(self):
        return _optim.NearestPointChecker_getComparisonOperator(self)

    def setThreshold(self, threshold):
        return _optim.NearestPointChecker_setThreshold(self, threshold)

    def getThreshold(self):
        return _optim.NearestPointChecker_getThreshold(self)

    def setSample(self, sample):
        return _optim.NearestPointChecker_setSample(self, sample)

    def getSample(self):
        return _optim.NearestPointChecker_getSample(self)

    def run(self):
        return _optim.NearestPointChecker_run(self)

    def __repr__(self):
        return _optim.NearestPointChecker___repr__(self)

    def __init__(self, *args):
        this = _optim.new_NearestPointChecker(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_NearestPointChecker
    __del__ = lambda self: None
NearestPointChecker_swigregister = _optim.NearestPointChecker_swigregister
NearestPointChecker_swigregister(NearestPointChecker)

class AbdoRackwitzSpecificParameters(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AbdoRackwitzSpecificParameters, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, AbdoRackwitzSpecificParameters, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.AbdoRackwitzSpecificParameters_getClassName(self)


    def getTau(self):
        return _optim.AbdoRackwitzSpecificParameters_getTau(self)

    def setTau(self, tau):
        return _optim.AbdoRackwitzSpecificParameters_setTau(self, tau)

    def getOmega(self):
        return _optim.AbdoRackwitzSpecificParameters_getOmega(self)

    def setOmega(self, tau):
        return _optim.AbdoRackwitzSpecificParameters_setOmega(self, tau)

    def getSmooth(self):
        return _optim.AbdoRackwitzSpecificParameters_getSmooth(self)

    def setSmooth(self, tau):
        return _optim.AbdoRackwitzSpecificParameters_setSmooth(self, tau)

    def __repr__(self):
        return _optim.AbdoRackwitzSpecificParameters___repr__(self)

    def __init__(self, *args):
        this = _optim.new_AbdoRackwitzSpecificParameters(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_AbdoRackwitzSpecificParameters
    __del__ = lambda self: None
AbdoRackwitzSpecificParameters_swigregister = _optim.AbdoRackwitzSpecificParameters_swigregister
AbdoRackwitzSpecificParameters_swigregister(AbdoRackwitzSpecificParameters)

class AbdoRackwitz(OptimizationSolverImplementation):
    """
    Abdo-Rackwitz solver.

    Available constructors:
        AbdoRackwitz(*problem*)

        AbdoRackwitz(*problem, tau, omega, smooth*)

    Parameters
    ----------
    problem : :class:`~openturns.OptimizationProblem`
        Optimization problem to solve.
    tau : float
        Multiplicative decrease of linear step.
    omega : float
        Armijo factor.
    smooth : float
        Growing factor in penalization term.

    See also
    --------
    Cobyla, SQP, TNC

    Examples
    --------
    >>> import openturns as ot
    >>> model = ot.NumericalMathFunction(['E', 'F', 'L', 'I'], ['d'], ['-F*L^3/(3*E*I)'])
    >>> problem = ot.OptimizationProblem(model, 5.0)
    >>> algo = ot.AbdoRackwitz(problem)
    """

    __swig_setmethods__ = {}
    for _s in [OptimizationSolverImplementation]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AbdoRackwitz, name, value)
    __swig_getmethods__ = {}
    for _s in [OptimizationSolverImplementation]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, AbdoRackwitz, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.AbdoRackwitz_getClassName(self)


    def run(self):
        """Launch the optimization."""
        return _optim.AbdoRackwitz_run(self)


    def getTau(self):
        """
        Accessor to tau parameter.

        Returns
        -------
        tau : float
            Multiplicative decrease of linear step.
        """
        return _optim.AbdoRackwitz_getTau(self)


    def setTau(self, tau):
        """
        Accessor to tau parameter.

        Parameters
        ----------
        tau : float
            Multiplicative decrease of linear step.
        """
        return _optim.AbdoRackwitz_setTau(self, tau)


    def getOmega(self):
        """
        Accessor to omega parameter.

        Returns
        -------
        omega : float
            Armijo factor.
        """
        return _optim.AbdoRackwitz_getOmega(self)


    def setOmega(self, tau):
        """
        Accessor to omega parameter.

        Parameters
        ----------
        omega : float
            Armijo factor.
        """
        return _optim.AbdoRackwitz_setOmega(self, tau)


    def getSmooth(self):
        """
        Accessor to smooth parameter.

        Returns
        -------
        smooth : float
            Growing factor in penalization term.
        """
        return _optim.AbdoRackwitz_getSmooth(self)


    def setSmooth(self, tau):
        """
        Accessor to smooth parameter.

        Parameters
        ----------
        smooth : float
            Growing factor in penalization term.
        """
        return _optim.AbdoRackwitz_setSmooth(self, tau)


    def getSpecificParameters(self):
        return _optim.AbdoRackwitz_getSpecificParameters(self)

    def setSpecificParameters(self, specificParameters):
        return _optim.AbdoRackwitz_setSpecificParameters(self, specificParameters)

    def getLevelFunction(self):
        return _optim.AbdoRackwitz_getLevelFunction(self)

    def setLevelFunction(self, levelFunction):
        return _optim.AbdoRackwitz_setLevelFunction(self, levelFunction)

    def getLevelValue(self):
        return _optim.AbdoRackwitz_getLevelValue(self)

    def setLevelValue(self, levelValue):
        return _optim.AbdoRackwitz_setLevelValue(self, levelValue)

    def __repr__(self):
        return _optim.AbdoRackwitz___repr__(self)

    def __init__(self, *args):
        this = _optim.new_AbdoRackwitz(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_AbdoRackwitz
    __del__ = lambda self: None
AbdoRackwitz_swigregister = _optim.AbdoRackwitz_swigregister
AbdoRackwitz_swigregister(AbdoRackwitz)

class CobylaSpecificParameters(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CobylaSpecificParameters, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, CobylaSpecificParameters, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.CobylaSpecificParameters_getClassName(self)


    def getRhoBeg(self):
        return _optim.CobylaSpecificParameters_getRhoBeg(self)

    def setRhoBeg(self, rhoBeg):
        return _optim.CobylaSpecificParameters_setRhoBeg(self, rhoBeg)

    def __repr__(self):
        return _optim.CobylaSpecificParameters___repr__(self)

    def __init__(self, *args):
        this = _optim.new_CobylaSpecificParameters(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_CobylaSpecificParameters
    __del__ = lambda self: None
CobylaSpecificParameters_swigregister = _optim.CobylaSpecificParameters_swigregister
CobylaSpecificParameters_swigregister(CobylaSpecificParameters)

class Cobyla(OptimizationSolverImplementation):
    """
    Constrained Optimization BY Linear Approximations solver.

    Available constructors:
        Cobyla(*problem*)

        Cobyla(*problem, rhoBeg*)

    Parameters
    ----------
    problem : :class:`~openturns.OptimizationProblem`
        Optimization problem to solve.
    rhoBeg : float
        A reasonable initial change to the variables.

    Notes
    -----
    It constructs successive linear approximations of the objective function and
    constraints via a simplex of :math:`d+1` points, and optimizes these
    approximations in a trust region at each step.

    See also
    --------
    AbdoRackwitz, SQP, TNC

    Examples
    --------
    >>> import openturns as ot
    >>> model = ot.NumericalMathFunction(['E', 'F', 'L', 'I'], ['d'], ['-F*L^3/(3*E*I)'])
    >>> problem = ot.OptimizationProblem(model, 5.0)
    >>> algo = ot.Cobyla(problem)
    """

    __swig_setmethods__ = {}
    for _s in [OptimizationSolverImplementation]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Cobyla, name, value)
    __swig_getmethods__ = {}
    for _s in [OptimizationSolverImplementation]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Cobyla, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.Cobyla_getClassName(self)


    def run(self):
        """Launch the optimization."""
        return _optim.Cobyla_run(self)


    def getRhoBeg(self):
        """
        Accessor to rhoBeg parameter.

        Returns
        -------
        rhoBeg : float
            A reasonable initial change to the variables.
        """
        return _optim.Cobyla_getRhoBeg(self)


    def setRhoBeg(self, rhoBeg):
        """
        Accessor to rhoBeg parameter.

        Parameters
        ----------
        rhoBeg : float
            A reasonable initial change to the variables.
        """
        return _optim.Cobyla_setRhoBeg(self, rhoBeg)


    def getSpecificParameters(self):
        return _optim.Cobyla_getSpecificParameters(self)

    def setSpecificParameters(self, specificParameters):
        return _optim.Cobyla_setSpecificParameters(self, specificParameters)

    def getLevelFunction(self):
        return _optim.Cobyla_getLevelFunction(self)

    def setLevelFunction(self, levelFunction):
        return _optim.Cobyla_setLevelFunction(self, levelFunction)

    def getLevelValue(self):
        return _optim.Cobyla_getLevelValue(self)

    def setLevelValue(self, levelValue):
        return _optim.Cobyla_setLevelValue(self, levelValue)

    def __repr__(self):
        return _optim.Cobyla___repr__(self)

    def __init__(self, *args):
        this = _optim.new_Cobyla(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_Cobyla
    __del__ = lambda self: None
Cobyla_swigregister = _optim.Cobyla_swigregister
Cobyla_swigregister(Cobyla)

class TNCSpecificParameters(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TNCSpecificParameters, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, TNCSpecificParameters, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.TNCSpecificParameters_getClassName(self)


    def getScale(self):
        return _optim.TNCSpecificParameters_getScale(self)

    def setScale(self, scale):
        return _optim.TNCSpecificParameters_setScale(self, scale)

    def getOffset(self):
        return _optim.TNCSpecificParameters_getOffset(self)

    def setOffset(self, offset):
        return _optim.TNCSpecificParameters_setOffset(self, offset)

    def getMaxCGit(self):
        return _optim.TNCSpecificParameters_getMaxCGit(self)

    def setMaxCGit(self, maxCGit):
        return _optim.TNCSpecificParameters_setMaxCGit(self, maxCGit)

    def getEta(self):
        return _optim.TNCSpecificParameters_getEta(self)

    def setEta(self, eta):
        return _optim.TNCSpecificParameters_setEta(self, eta)

    def getStepmx(self):
        return _optim.TNCSpecificParameters_getStepmx(self)

    def setStepmx(self, stepmx):
        return _optim.TNCSpecificParameters_setStepmx(self, stepmx)

    def getAccuracy(self):
        return _optim.TNCSpecificParameters_getAccuracy(self)

    def setAccuracy(self, accuracy):
        return _optim.TNCSpecificParameters_setAccuracy(self, accuracy)

    def getFmin(self):
        return _optim.TNCSpecificParameters_getFmin(self)

    def setFmin(self, fmin):
        return _optim.TNCSpecificParameters_setFmin(self, fmin)

    def getRescale(self):
        return _optim.TNCSpecificParameters_getRescale(self)

    def setRescale(self, rescale):
        return _optim.TNCSpecificParameters_setRescale(self, rescale)

    def __repr__(self):
        return _optim.TNCSpecificParameters___repr__(self)

    def __init__(self, *args):
        this = _optim.new_TNCSpecificParameters(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_TNCSpecificParameters
    __del__ = lambda self: None
TNCSpecificParameters_swigregister = _optim.TNCSpecificParameters_swigregister
TNCSpecificParameters_swigregister(TNCSpecificParameters)

class TNC(OptimizationSolverImplementation):
    """
    Truncated Newton Constrained solver.

    Available constructors:
        TNC(*problem*)

        TNC(*problem, scale, offset, maxCGit, eta, stepmx, accuracy, fmin, rescale*)

    Parameters
    ----------
    problem : :class:`~openturns.OptimizationProblem`
        Optimization problem to solve.
    specificParameters : :class:`~openturns.TNCSpecificParameters`
        Parameters for this solver.
    scale : sequence of float
        Scaling factors to apply to each variables
    offset : sequence of float
        Constant to substract to each variable
    maxCGit : int
        Maximum number of hessian*vector evaluation per main iteration
    eta : float
        Severity of the line search.
    stepmx : float
        Maximum step for the line search. may be increased during call
    accuracy : float
        Relative precision for finite difference calculations
    fmin : float
        Minimum function value estimate.
    rescale : float
        f scaling factor (in log10) used to trigger f value rescaling

    Notes
    -----
    Non-linear optimizer supporting bound constraints.

    See also
    --------
    AbdoRackwitz, SQP, Cobyla

    Examples
    --------
    >>> import openturns as ot
    >>> model = ot.NumericalMathFunction(['E', 'F', 'L', 'I'], ['d'], ['-F*L^3/(3*E*I)'])
    >>> bounds = ot.Interval([1.]*4, [2.]*4)
    >>> problem = ot.OptimizationProblem(model, ot.NumericalMathFunction(), ot.NumericalMathFunction(), bounds)
    >>> algo = ot.TNC(problem)
    """

    __swig_setmethods__ = {}
    for _s in [OptimizationSolverImplementation]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TNC, name, value)
    __swig_getmethods__ = {}
    for _s in [OptimizationSolverImplementation]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, TNC, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.TNC_getClassName(self)


    def run(self):
        """Launch the optimization."""
        return _optim.TNC_run(self)


    def getScale(self):
        """
        Accessor to scale parameter.

        Returns
        -------
        scale : :class:`~openturns.NumericalPoint`
            Scaling factors to apply to each variable

            if empty, the factors are min-max for interval bounded variables

            and 1+|x] for the others.
        """
        return _optim.TNC_getScale(self)


    def setScale(self, scale):
        """
        Accessor to scale parameter.

        Parameters
        ----------
        scale : sequence of float
            Scaling factors to apply to each variable

            if empty, the factors are min-max for interval bounded variables

            and 1+|x] for the others.
        """
        return _optim.TNC_setScale(self, scale)


    def getOffset(self):
        """
        Accessor to offset parameter.

        Returns
        -------
        offset : :class:`~openturns.NumericalPoint`
            Constant to substract to each variable

            if empty, the constant are (min-max)/2 for interval bounded

            variables and x for the others.
        """
        return _optim.TNC_getOffset(self)


    def setOffset(self, offset):
        """
        Accessor to offset parameter.

        Parameters
        ----------
        offset : sequence of float
            Constant to substract to each variable

            if empty, the constant are (min-max)/2 for interval bounded

            variables and x for the others.
        """
        return _optim.TNC_setOffset(self, offset)


    def getMaxCGit(self):
        """
        Accessor to maxCGit parameter.

        Returns
        -------
        maxCGit : int
            Maximum number of hessian*vector evaluation per main iteration

            if maxCGit = 0, the direction chosen is -gradient

            if maxCGit < 0, maxCGit is set to max(1,min(50,n/2)).
        """
        return _optim.TNC_getMaxCGit(self)


    def setMaxCGit(self, maxCGit):
        """
        Accessor to maxCGit parameter.

        Parameters
        ----------
        maxCGit : int
            Maximum number of hessian*vector evaluation per main iteration

            if maxCGit = 0, the direction chosen is -gradient

            if maxCGit < 0, maxCGit is set to max(1,min(50,n/2)).
        """
        return _optim.TNC_setMaxCGit(self, maxCGit)


    def getEta(self):
        """
        Accessor to eta parameter.

        Returns
        -------
        eta : float
            Severity of the line search.

            if < 0 or > 1, set to 0.25.
        """
        return _optim.TNC_getEta(self)


    def setEta(self, eta):
        """
        Accessor to eta parameter.

        Parameters
        ----------
        eta : float
            Severity of the line search.

            if < 0 or > 1, set to 0.25.
        """
        return _optim.TNC_setEta(self, eta)


    def getStepmx(self):
        """
        Accessor to stepmx parameter.

        Returns
        -------
        stepmx : float
            Maximum step for the line search. may be increased during call

            if too small, will be set to 10.0.
        """
        return _optim.TNC_getStepmx(self)


    def setStepmx(self, stepmx):
        """
        Accessor to stepmx parameter.

        Parameters
        ----------
        stepmx : float
            Maximum step for the line search. may be increased during call

            if too small, will be set to 10.0.
        """
        return _optim.TNC_setStepmx(self, stepmx)


    def getAccuracy(self):
        """
        Accessor to accuracy parameter.

        Returns
        -------
        accuracy : float
            Relative precision for finite difference calculations

            if <= machine_precision, set to sqrt(machine_precision).
        """
        return _optim.TNC_getAccuracy(self)


    def setAccuracy(self, accuracy):
        """
        Accessor to accuracy parameter.

        Parameters
        ----------
        accuracy : float
            Relative precision for finite difference calculations

            if <= machine_precision, set to sqrt(machine_precision).
        """
        return _optim.TNC_setAccuracy(self, accuracy)


    def getFmin(self):
        """
        Accessor to fmin parameter.

        Returns
        -------
        fmin : float
            Minimum function value estimate.
        """
        return _optim.TNC_getFmin(self)


    def setFmin(self, fmin):
        """
        Accessor to fmin parameter.

        Parameters
        ----------
        fmin : float
            Minimum function value estimate.
        """
        return _optim.TNC_setFmin(self, fmin)


    def getRescale(self):
        """
        Accessor to rescale parameter.

        Returns
        -------
        rescale : float
            f scaling factor (in log10) used to trigger f value rescaling

            if 0, rescale at each iteration

            if a big value, never rescale

            if < 0, rescale is set to 1.3.
        """
        return _optim.TNC_getRescale(self)


    def setRescale(self, rescale):
        """
        Accessor to rescale parameter.

        Parameters
        ----------
        rescale : float
            f scaling factor (in log10) used to trigger f value rescaling

            if 0, rescale at each iteration

            if a big value, never rescale

            if < 0, rescale is set to 1.3.
        """
        return _optim.TNC_setRescale(self, rescale)


    def getSpecificParameters(self):
        return _optim.TNC_getSpecificParameters(self)

    def setSpecificParameters(self, specificParameters):
        return _optim.TNC_setSpecificParameters(self, specificParameters)

    def __repr__(self):
        return _optim.TNC___repr__(self)

    def __init__(self, *args):
        this = _optim.new_TNC(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_TNC
    __del__ = lambda self: None
TNC_swigregister = _optim.TNC_swigregister
TNC_swigregister(TNC)

class SQPSpecificParameters(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SQPSpecificParameters, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, SQPSpecificParameters, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.SQPSpecificParameters_getClassName(self)


    def getTau(self):
        return _optim.SQPSpecificParameters_getTau(self)

    def setTau(self, tau):
        return _optim.SQPSpecificParameters_setTau(self, tau)

    def getOmega(self):
        return _optim.SQPSpecificParameters_getOmega(self)

    def setOmega(self, tau):
        return _optim.SQPSpecificParameters_setOmega(self, tau)

    def getSmooth(self):
        return _optim.SQPSpecificParameters_getSmooth(self)

    def setSmooth(self, tau):
        return _optim.SQPSpecificParameters_setSmooth(self, tau)

    def __repr__(self):
        return _optim.SQPSpecificParameters___repr__(self)

    def __init__(self, *args):
        this = _optim.new_SQPSpecificParameters(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_SQPSpecificParameters
    __del__ = lambda self: None
SQPSpecificParameters_swigregister = _optim.SQPSpecificParameters_swigregister
SQPSpecificParameters_swigregister(SQPSpecificParameters)

class SQP(OptimizationSolverImplementation):
    """
    Sequential Quadratic Programming solver.

    Available constructors:
        SQP(*problem*)

        SQP(*problem, tau, omega, smooth*)

    Parameters
    ----------
    problem : :class:`~openturns.OptimizationProblem`
        Optimization problem to solve.
    tau : float
        Multiplicative decrease of linear step.
    omega : float
        Armijo factor.
    smooth : float
        Growing factor in penalization term.

    Notes
    -----
    SQP methods solve a sequence of optimization subproblems,
    each of which optimizes a quadratic model of the objective
    subject to a linearization of the constraints.

    See also
    --------
    AbdoRackwitz, Cobyla, TNC

    Examples
    --------
    >>> import openturns as ot
    >>> model = ot.NumericalMathFunction(['E', 'F', 'L', 'I'], ['d'], ['-F*L^3/(3*E*I)'])
    >>> problem = ot.OptimizationProblem(model, 5.0)
    >>> algo = ot.SQP(problem)
    """

    __swig_setmethods__ = {}
    for _s in [OptimizationSolverImplementation]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SQP, name, value)
    __swig_getmethods__ = {}
    for _s in [OptimizationSolverImplementation]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, SQP, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.SQP_getClassName(self)


    def run(self):
        """Launch the optimization."""
        return _optim.SQP_run(self)


    def getTau(self):
        """
        Accessor to tau parameter.

        Returns
        -------
        tau : float
            Multiplicative decrease of linear step.
        """
        return _optim.SQP_getTau(self)


    def setTau(self, tau):
        """
        Accessor to tau parameter.

        Parameters
        ----------
        tau : float
            Multiplicative decrease of linear step.
        """
        return _optim.SQP_setTau(self, tau)


    def getOmega(self):
        """
        Accessor to omega parameter.

        Returns
        -------
        omega : float
            Armijo factor.
        """
        return _optim.SQP_getOmega(self)


    def setOmega(self, tau):
        """
        Accessor to omega parameter.

        Parameters
        ----------
        omega : float
            Armijo factor.
        """
        return _optim.SQP_setOmega(self, tau)


    def getSmooth(self):
        """
        Accessor to smooth parameter.

        Returns
        -------
        smooth : float
            Growing factor in penalization term.
        """
        return _optim.SQP_getSmooth(self)


    def setSmooth(self, tau):
        """
        Accessor to smooth parameter.

        Parameters
        ----------
        smooth : float
            Growing factor in penalization term.
        """
        return _optim.SQP_setSmooth(self, tau)


    def getSpecificParameters(self):
        return _optim.SQP_getSpecificParameters(self)

    def setSpecificParameters(self, specificParameters):
        return _optim.SQP_setSpecificParameters(self, specificParameters)

    def getLevelFunction(self):
        return _optim.SQP_getLevelFunction(self)

    def setLevelFunction(self, levelFunction):
        return _optim.SQP_setLevelFunction(self, levelFunction)

    def getLevelValue(self):
        return _optim.SQP_getLevelValue(self)

    def setLevelValue(self, levelValue):
        return _optim.SQP_setLevelValue(self, levelValue)

    def __repr__(self):
        return _optim.SQP___repr__(self)

    def __init__(self, *args):
        this = _optim.new_SQP(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_SQP
    __del__ = lambda self: None
SQP_swigregister = _optim.SQP_swigregister
SQP_swigregister(SQP)

class NLopt(OptimizationSolverImplementation):
    __swig_setmethods__ = {}
    for _s in [OptimizationSolverImplementation]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NLopt, name, value)
    __swig_getmethods__ = {}
    for _s in [OptimizationSolverImplementation]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, NLopt, name)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.NLopt_getClassName(self)


    def run(self):
        """Launch the optimization."""
        return _optim.NLopt_run(self)


    def __repr__(self):
        return _optim.NLopt___repr__(self)

    def __init__(self, *args):
        this = _optim.new_NLopt(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_NLopt
    __del__ = lambda self: None
NLopt_swigregister = _optim.NLopt_swigregister
NLopt_swigregister(NLopt)

class SLSQP(NLopt):
    """
    Sequential Least-Squares Quadratic Programming solver.

    Parameters
    ----------
    problem : :class:`~openturns.OptimizationProblem`
        Optimization problem to solve.

    See also
    --------
    AbdoRackwitz, Cobyla, SQP, TNC

    Examples
    --------
    >>> import openturns as ot
    >>> dim = 4
    >>> bounds = ot.Interval([-3.] * dim, [5.] * dim)
    >>> linear = ot.NumericalMathFunction(['x1', 'x2', 'x3', 'x4'], ['y1'], ['x1+2*x2-3*x3+4*x4'])
    >>> problem = ot.OptimizationProblem(linear, ot.NumericalMathFunction(), ot.NumericalMathFunction(), bounds)
    >>> algo = ot.SLSQP(problem)
    """

    __swig_setmethods__ = {}
    for _s in [NLopt]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SLSQP, name, value)
    __swig_getmethods__ = {}
    for _s in [NLopt]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, SLSQP, name)
    __repr__ = _swig_repr

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.SLSQP_getClassName(self)


    def __init__(self, *args):
        this = _optim.new_SLSQP(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_SLSQP
    __del__ = lambda self: None
SLSQP_swigregister = _optim.SLSQP_swigregister
SLSQP_swigregister(SLSQP)

class LBFGS(NLopt):
    """
    Low-storage BFGS algorithm.

    Parameters
    ----------
    problem : :class:`~openturns.OptimizationProblem`
        Optimization problem to solve.

    See also
    --------
    AbdoRackwitz, Cobyla, SQP, TNC

    Examples
    --------
    >>> import openturns as ot
    >>> dim = 4
    >>> bounds = ot.Interval([-3.] * dim, [5.] * dim)
    >>> linear = ot.NumericalMathFunction(['x1', 'x2', 'x3', 'x4'], ['y1'], ['x1+2*x2-3*x3+4*x4'])
    >>> problem = ot.OptimizationProblem(linear, ot.NumericalMathFunction(), ot.NumericalMathFunction(), bounds)
    >>> algo = ot.LBFGS(problem)
    """

    __swig_setmethods__ = {}
    for _s in [NLopt]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LBFGS, name, value)
    __swig_getmethods__ = {}
    for _s in [NLopt]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, LBFGS, name)
    __repr__ = _swig_repr

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.LBFGS_getClassName(self)


    def __init__(self, *args):
        this = _optim.new_LBFGS(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_LBFGS
    __del__ = lambda self: None
LBFGS_swigregister = _optim.LBFGS_swigregister
LBFGS_swigregister(LBFGS)

class NelderMead(NLopt):
    """
    Nelder-Mead simplex algorithm.

    Parameters
    ----------
    problem : :class:`~openturns.OptimizationProblem`
        Optimization problem to solve.

    See also
    --------
    AbdoRackwitz, Cobyla, SQP, TNC

    Examples
    --------
    >>> import openturns as ot
    >>> dim = 4
    >>> bounds = ot.Interval([-3.] * dim, [5.] * dim)
    >>> linear = ot.NumericalMathFunction(['x1', 'x2', 'x3', 'x4'], ['y1'], ['x1+2*x2-3*x3+4*x4'])
    >>> problem = ot.OptimizationProblem(linear, ot.NumericalMathFunction(), ot.NumericalMathFunction(), bounds)
    >>> algo = ot.NelderMead(problem)
    """

    __swig_setmethods__ = {}
    for _s in [NLopt]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NelderMead, name, value)
    __swig_getmethods__ = {}
    for _s in [NLopt]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, NelderMead, name)
    __repr__ = _swig_repr

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.NelderMead_getClassName(self)


    def __init__(self, *args):
        this = _optim.new_NelderMead(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_NelderMead
    __del__ = lambda self: None
NelderMead_swigregister = _optim.NelderMead_swigregister
NelderMead_swigregister(NelderMead)

class SolverImplementationPointer(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SolverImplementationPointer, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SolverImplementationPointer, name)
    __repr__ = _swig_repr
    __swig_setmethods__["ptr_"] = _optim.SolverImplementationPointer_ptr__set
    __swig_getmethods__["ptr_"] = _optim.SolverImplementationPointer_ptr__get
    if _newclass:
        ptr_ = _swig_property(_optim.SolverImplementationPointer_ptr__get, _optim.SolverImplementationPointer_ptr__set)

    def __init__(self, *args):
        this = _optim.new_SolverImplementationPointer(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_SolverImplementationPointer
    __del__ = lambda self: None

    def reset(self):
        return _optim.SolverImplementationPointer_reset(self)

    def __ref__(self, *args):
        return _optim.SolverImplementationPointer___ref__(self, *args)

    def __deref__(self):
        return _optim.SolverImplementationPointer___deref__(self)

    def isNull(self):
        return _optim.SolverImplementationPointer_isNull(self)

    def __nonzero__(self):
        return _optim.SolverImplementationPointer___nonzero__(self)
    __bool__ = __nonzero__



    def get(self):
        return _optim.SolverImplementationPointer_get(self)

    def getImplementation(self):
        return _optim.SolverImplementationPointer_getImplementation(self)

    def unique(self):
        return _optim.SolverImplementationPointer_unique(self)

    def use_count(self):
        return _optim.SolverImplementationPointer_use_count(self)

    def swap(self, other):
        return _optim.SolverImplementationPointer_swap(self, other)
SolverImplementationPointer_swigregister = _optim.SolverImplementationPointer_swigregister
SolverImplementationPointer_swigregister(SolverImplementationPointer)

class OptimizationProblemImplementationPointer(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, OptimizationProblemImplementationPointer, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, OptimizationProblemImplementationPointer, name)
    __swig_setmethods__["ptr_"] = _optim.OptimizationProblemImplementationPointer_ptr__set
    __swig_getmethods__["ptr_"] = _optim.OptimizationProblemImplementationPointer_ptr__get
    if _newclass:
        ptr_ = _swig_property(_optim.OptimizationProblemImplementationPointer_ptr__get, _optim.OptimizationProblemImplementationPointer_ptr__set)

    def __init__(self, *args):
        this = _optim.new_OptimizationProblemImplementationPointer(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_OptimizationProblemImplementationPointer
    __del__ = lambda self: None

    def reset(self):
        return _optim.OptimizationProblemImplementationPointer_reset(self)

    def __ref__(self, *args):
        return _optim.OptimizationProblemImplementationPointer___ref__(self, *args)

    def __deref__(self):
        return _optim.OptimizationProblemImplementationPointer___deref__(self)

    def isNull(self):
        return _optim.OptimizationProblemImplementationPointer_isNull(self)

    def __nonzero__(self):
        return _optim.OptimizationProblemImplementationPointer___nonzero__(self)
    __bool__ = __nonzero__



    def get(self):
        return _optim.OptimizationProblemImplementationPointer_get(self)

    def getImplementation(self):
        return _optim.OptimizationProblemImplementationPointer_getImplementation(self)

    def unique(self):
        return _optim.OptimizationProblemImplementationPointer_unique(self)

    def use_count(self):
        return _optim.OptimizationProblemImplementationPointer_use_count(self)

    def swap(self, other):
        return _optim.OptimizationProblemImplementationPointer_swap(self, other)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.OptimizationProblemImplementationPointer_getClassName(self)


    def getObjective(self):
        """
        Accessor to objective function.

        Returns
        -------
        objective : :class:`~openturns.NumericalMathFunction`
            Objective function.
        """
        return _optim.OptimizationProblemImplementationPointer_getObjective(self)


    def setObjective(self, objective):
        """
        Accessor to objective function.

        Parameters
        ----------
        objectiveFunction : :class:`~openturns.NumericalMathFunction`
            Objective function.
        """
        return _optim.OptimizationProblemImplementationPointer_setObjective(self, objective)


    def hasMultipleObjective(self):
        """
        Test whether objective function is a scalar or vector function.

        Returns
        -------
        value : bool
            *False* if objective function is scalar, *True* otherwise.
        """
        return _optim.OptimizationProblemImplementationPointer_hasMultipleObjective(self)


    def getEqualityConstraint(self):
        """
        Accessor to equality constraints.

        Returns
        -------
        equality : :class:`~openturns.NumericalMathFunction`
            Describe equality constraints.
        """
        return _optim.OptimizationProblemImplementationPointer_getEqualityConstraint(self)


    def setEqualityConstraint(self, equalityConstraint):
        """
        Accessor to equality constraints.

        Parameters
        ----------
        equalityConstraint : :class:`~openturns.NumericalMathFunction`
            Equality constraints.
        """
        return _optim.OptimizationProblemImplementationPointer_setEqualityConstraint(self, equalityConstraint)


    def hasEqualityConstraint(self):
        """
        Test whether equality constraints had been specified.

        Returns
        -------
        value : bool
            *True* if equality constraints had been set for this problem, *False* otherwise.
        """
        return _optim.OptimizationProblemImplementationPointer_hasEqualityConstraint(self)


    def getInequalityConstraint(self):
        """
        Accessor to inequality constraints.

        Returns
        -------
        inequality : :class:`~openturns.NumericalMathFunction`
            Describe inequality constraints.
        """
        return _optim.OptimizationProblemImplementationPointer_getInequalityConstraint(self)


    def setInequalityConstraint(self, inequalityConstraint):
        """
        Accessor to inequality constraints.

        Parameters
        ----------
        inequalityConstraint : :class:`~openturns.NumericalMathFunction`
            Inequality constraints.
        """
        return _optim.OptimizationProblemImplementationPointer_setInequalityConstraint(self, inequalityConstraint)


    def hasInequalityConstraint(self):
        """
        Test whether inequality constraints had been specified.

        Returns
        -------
        value : bool
            *True* if inequality constraints had been set for this problem, *False* otherwise.
        """
        return _optim.OptimizationProblemImplementationPointer_hasInequalityConstraint(self)


    def getBounds(self):
        """
        Accessor to bounds.

        Returns
        -------
        bounds : :class:`~openturns.Interval`
            Problem bounds.
        """
        return _optim.OptimizationProblemImplementationPointer_getBounds(self)


    def setBounds(self, bounds):
        """
        Accessor to bounds.

        Parameters
        ----------
        bounds : :class:`~openturns.Interval`
            Problem bounds.
        """
        return _optim.OptimizationProblemImplementationPointer_setBounds(self, bounds)


    def hasBounds(self):
        """
        Test whether bounds had been specified.

        Returns
        -------
        value : bool
            *True* if bounds had been set for this problem, *False* otherwise.
        """
        return _optim.OptimizationProblemImplementationPointer_hasBounds(self)


    def getLevelFunction(self):
        """
        Accessor to level function.

        Returns
        -------
        level : :class:`~openturns.NumericalMathFunction`
            Level function.
        """
        return _optim.OptimizationProblemImplementationPointer_getLevelFunction(self)


    def setLevelFunction(self, levelFunction):
        """
        Accessor to level function.

        Parameters
        ----------
        levelFunction : :class:`~openturns.NumericalMathFunction`
            Level function.
        """
        return _optim.OptimizationProblemImplementationPointer_setLevelFunction(self, levelFunction)


    def hasLevelFunction(self):
        """
        Test whether level function had been specified.

        Returns
        -------
        value : bool
            *True* if level function had been set for this problem, *False* otherwise.
        """
        return _optim.OptimizationProblemImplementationPointer_hasLevelFunction(self)


    def getLevelValue(self):
        """
        Accessor to level value.

        Returns
        -------
        value : float
            Level value.
        """
        return _optim.OptimizationProblemImplementationPointer_getLevelValue(self)


    def setLevelValue(self, levelValue):
        """
        Accessor to level value.

        Parameters
        ----------
        levelValue : float
            Level value.
        """
        return _optim.OptimizationProblemImplementationPointer_setLevelValue(self, levelValue)


    def getDimension(self):
        """
        Accessor to spatial dimension.

        Returns
        -------
        dimension : int
            Input dimension of objective function.
        """
        return _optim.OptimizationProblemImplementationPointer_getDimension(self)


    def setMinimization(self, minimization):
        """
        Tell whether this is a minimization or maximization problem.

        Parameters
        ----------
        minimization : bool
            *True* if this is a minimization problem, *False* otherwise.
        """
        return _optim.OptimizationProblemImplementationPointer_setMinimization(self, minimization)


    def isMinimization(self):
        """
        Test whether this is a minimization or maximization problem.

        Returns
        -------
        value : bool
            *True* if this is a minimization problem (default), *False* otherwise.
        """
        return _optim.OptimizationProblemImplementationPointer_isMinimization(self)


    def __repr__(self):
        return _optim.OptimizationProblemImplementationPointer___repr__(self)

    def __eq__(self, other):
        return _optim.OptimizationProblemImplementationPointer___eq__(self, other)

    def __ne__(self, other):
        return _optim.OptimizationProblemImplementationPointer___ne__(self, other)

    def __str__(self, *args):
        return _optim.OptimizationProblemImplementationPointer___str__(self, *args)

    def getId(self):
        """
        Accessor to the object's id.

        Returns
        -------
        id : int
           Internal unique identifier.
        """
        return _optim.OptimizationProblemImplementationPointer_getId(self)


    def setShadowedId(self, id):
        """
        Accessor to the object's shadowed id.

        Parameters
        ----------
        id : int
            Internal unique identifier.
        """
        return _optim.OptimizationProblemImplementationPointer_setShadowedId(self, id)


    def getShadowedId(self):
        """
        Accessor to the object's shadowed id.

        Returns
        -------
        id : int
            Internal unique identifier.
        """
        return _optim.OptimizationProblemImplementationPointer_getShadowedId(self)


    def setVisibility(self, visible):
        """
        Accessor to the object's visibility state.

        Parameters
        ----------
        visible : bool
            Visibility flag.
        """
        return _optim.OptimizationProblemImplementationPointer_setVisibility(self, visible)


    def getVisibility(self):
        """
        Accessor to the object's visibility state.

        Returns
        -------
        visible : bool
            Visibility flag.
        """
        return _optim.OptimizationProblemImplementationPointer_getVisibility(self)


    def hasName(self):
        """
        Test if the object is named.

        Returns
        -------
        hasName : bool
            True if the name is not empty.
        """
        return _optim.OptimizationProblemImplementationPointer_hasName(self)


    def hasVisibleName(self):
        """
        Test if the object has a distinguishable name.

        Returns
        -------
        hasVisibleName : bool
            True if the name is not empty and not the default one.
        """
        return _optim.OptimizationProblemImplementationPointer_hasVisibleName(self)


    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : str
            The name of the object.
        """
        return _optim.OptimizationProblemImplementationPointer_getName(self)


    def setName(self, name):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _optim.OptimizationProblemImplementationPointer_setName(self, name)

OptimizationProblemImplementationPointer_swigregister = _optim.OptimizationProblemImplementationPointer_swigregister
OptimizationProblemImplementationPointer_swigregister(OptimizationProblemImplementationPointer)

class OptimizationSolverImplementationPointer(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, OptimizationSolverImplementationPointer, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, OptimizationSolverImplementationPointer, name)
    __swig_setmethods__["ptr_"] = _optim.OptimizationSolverImplementationPointer_ptr__set
    __swig_getmethods__["ptr_"] = _optim.OptimizationSolverImplementationPointer_ptr__get
    if _newclass:
        ptr_ = _swig_property(_optim.OptimizationSolverImplementationPointer_ptr__get, _optim.OptimizationSolverImplementationPointer_ptr__set)

    def __init__(self, *args):
        this = _optim.new_OptimizationSolverImplementationPointer(*args)
        try:
            self.this.append(this)
        except Exception:
            self.this = this
    __swig_destroy__ = _optim.delete_OptimizationSolverImplementationPointer
    __del__ = lambda self: None

    def reset(self):
        return _optim.OptimizationSolverImplementationPointer_reset(self)

    def __ref__(self, *args):
        return _optim.OptimizationSolverImplementationPointer___ref__(self, *args)

    def __deref__(self):
        return _optim.OptimizationSolverImplementationPointer___deref__(self)

    def isNull(self):
        return _optim.OptimizationSolverImplementationPointer_isNull(self)

    def __nonzero__(self):
        return _optim.OptimizationSolverImplementationPointer___nonzero__(self)
    __bool__ = __nonzero__



    def get(self):
        return _optim.OptimizationSolverImplementationPointer_get(self)

    def getImplementation(self):
        return _optim.OptimizationSolverImplementationPointer_getImplementation(self)

    def unique(self):
        return _optim.OptimizationSolverImplementationPointer_unique(self)

    def use_count(self):
        return _optim.OptimizationSolverImplementationPointer_use_count(self)

    def swap(self, other):
        return _optim.OptimizationSolverImplementationPointer_swap(self, other)

    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _optim.OptimizationSolverImplementationPointer_getClassName(self)


    def run(self):
        """Launch the optimization."""
        return _optim.OptimizationSolverImplementationPointer_run(self)


    def getStartingPoint(self):
        """
        Accessor to starting point.

        Returns
        -------
        startingPoint : :class:`~openturns.NumericalPoint`
            Starting point.
        """
        return _optim.OptimizationSolverImplementationPointer_getStartingPoint(self)


    def setStartingPoint(self, startingPoint):
        """
        Accessor to starting point.

        Parameters
        ----------
        startingPoint : :class:`~openturns.NumericalPoint`
            Starting point.
        """
        return _optim.OptimizationSolverImplementationPointer_setStartingPoint(self, startingPoint)


    def getProblem(self):
        """
        Accessor to optimization problem.

        Returns
        -------
        problem : :class:`~openturns.OptimizationProblem`
            Optimization problem.
        """
        return _optim.OptimizationSolverImplementationPointer_getProblem(self)


    def setProblem(self, problem):
        """
        Accessor to optimization problem.

        Parameters
        ----------
        problem : :class:`~openturns.OptimizationProblem`
            Optimization problem.
        """
        return _optim.OptimizationSolverImplementationPointer_setProblem(self, problem)


    def getResult(self):
        """
        Accessor to optimization result.

        Returns
        -------
        result : :class:`~openturns.OptimizationResult`
            Result class.
        """
        return _optim.OptimizationSolverImplementationPointer_getResult(self)


    def setResult(self, result):
        """
        Accessor to optimization result.

        Parameters
        ----------
        result : :class:`~openturns.OptimizationResult`
            Result class.
        """
        return _optim.OptimizationSolverImplementationPointer_setResult(self, result)


    def setMaximumIterationNumber(self, maximumIterationNumber):
        """
        Accessor to maximum allowed number of iterations.

        Parameters
        ----------
        N : int
            Maximum allowed number of iterations.
        """
        return _optim.OptimizationSolverImplementationPointer_setMaximumIterationNumber(self, maximumIterationNumber)


    def getMaximumIterationNumber(self):
        """
        Accessor to maximum allowed number of iterations.

        Returns
        -------
        N : int
            Maximum allowed number of iterations.
        """
        return _optim.OptimizationSolverImplementationPointer_getMaximumIterationNumber(self)


    def setMaximumIterationsNumber(self, maximumIterationsNumber):
        return _optim.OptimizationSolverImplementationPointer_setMaximumIterationsNumber(self, maximumIterationsNumber)

    def getMaximumIterationsNumber(self):
        return _optim.OptimizationSolverImplementationPointer_getMaximumIterationsNumber(self)

    def setMaximumEvaluationNumber(self, maximumEvaluationNumber):
        """
        Accessor to maximum allowed number of evaluations.

        Parameters
        ----------
        N : int
            Maximum allowed number of evaluations.
        """
        return _optim.OptimizationSolverImplementationPointer_setMaximumEvaluationNumber(self, maximumEvaluationNumber)


    def getMaximumEvaluationNumber(self):
        """
        Accessor to maximum allowed number of evaluations.

        Returns
        -------
        N : int
            Maximum allowed number of evaluations.
        """
        return _optim.OptimizationSolverImplementationPointer_getMaximumEvaluationNumber(self)


    def getMaximumAbsoluteError(self):
        """
        Accessor to maximum allowed absolute error.

        Returns
        -------
        maximumAbsoluteError : float
            Maximum allowed absolute error.
        """
        return _optim.OptimizationSolverImplementationPointer_getMaximumAbsoluteError(self)


    def setMaximumAbsoluteError(self, maximumAbsoluteError):
        """
        Accessor to maximum allowed absolute error.

        Parameters
        ----------
        maximumAbsoluteError : float
            Maximum allowed absolute error.
        """
        return _optim.OptimizationSolverImplementationPointer_setMaximumAbsoluteError(self, maximumAbsoluteError)


    def getMaximumRelativeError(self):
        """
        Accessor to maximum allowed relative error.

        Returns
        -------
        maximumRelativeError : float
            Maximum allowed relative error.
        """
        return _optim.OptimizationSolverImplementationPointer_getMaximumRelativeError(self)


    def setMaximumRelativeError(self, maximumRelativeError):
        """
        Accessor to maximum allowed relative error.

        Parameters
        ----------
        maximumRelativeError : float
            Maximum allowed relative error.
        """
        return _optim.OptimizationSolverImplementationPointer_setMaximumRelativeError(self, maximumRelativeError)


    def getMaximumResidualError(self):
        """
        Accessor to maximum allowed residual error.

        Returns
        -------
        maximumResidualError : float
            Maximum allowed residual error.
        """
        return _optim.OptimizationSolverImplementationPointer_getMaximumResidualError(self)


    def setMaximumResidualError(self, maximumResidualError):
        """
        Accessor to maximum allowed residual error.

        Parameters
        ----------
        maximumResidualError : float
            Maximum allowed residual error.
        """
        return _optim.OptimizationSolverImplementationPointer_setMaximumResidualError(self, maximumResidualError)


    def getMaximumConstraintError(self):
        """
        Accessor to maximum allowed constraint error.

        Returns
        -------
        maximumConstraintError : float
            Maximum allowed constraint error.
        """
        return _optim.OptimizationSolverImplementationPointer_getMaximumConstraintError(self)


    def setMaximumConstraintError(self, maximumConstraintError):
        """
        Accessor to maximum allowed constraint error.

        Parameters
        ----------
        maximumConstraintError : float
            Maximum allowed constraint error.
        """
        return _optim.OptimizationSolverImplementationPointer_setMaximumConstraintError(self, maximumConstraintError)


    def __repr__(self):
        return _optim.OptimizationSolverImplementationPointer___repr__(self)

    def getVerbose(self):
        """
        Accessor to the verbosity flag.

        Returns
        ----------
        verbose : bool
            Verbosity flag state.
        """
        return _optim.OptimizationSolverImplementationPointer_getVerbose(self)


    def setVerbose(self, verbose):
        """
        Accessor to the verbosity flag.

        Parameters
        ----------
        verbose : bool
            Verbosity flag state.
        """
        return _optim.OptimizationSolverImplementationPointer_setVerbose(self, verbose)


    def __eq__(self, other):
        return _optim.OptimizationSolverImplementationPointer___eq__(self, other)

    def __ne__(self, other):
        return _optim.OptimizationSolverImplementationPointer___ne__(self, other)

    def __str__(self, *args):
        return _optim.OptimizationSolverImplementationPointer___str__(self, *args)

    def getId(self):
        """
        Accessor to the object's id.

        Returns
        -------
        id : int
           Internal unique identifier.
        """
        return _optim.OptimizationSolverImplementationPointer_getId(self)


    def setShadowedId(self, id):
        """
        Accessor to the object's shadowed id.

        Parameters
        ----------
        id : int
            Internal unique identifier.
        """
        return _optim.OptimizationSolverImplementationPointer_setShadowedId(self, id)


    def getShadowedId(self):
        """
        Accessor to the object's shadowed id.

        Returns
        -------
        id : int
            Internal unique identifier.
        """
        return _optim.OptimizationSolverImplementationPointer_getShadowedId(self)


    def setVisibility(self, visible):
        """
        Accessor to the object's visibility state.

        Parameters
        ----------
        visible : bool
            Visibility flag.
        """
        return _optim.OptimizationSolverImplementationPointer_setVisibility(self, visible)


    def getVisibility(self):
        """
        Accessor to the object's visibility state.

        Returns
        -------
        visible : bool
            Visibility flag.
        """
        return _optim.OptimizationSolverImplementationPointer_getVisibility(self)


    def hasName(self):
        """
        Test if the object is named.

        Returns
        -------
        hasName : bool
            True if the name is not empty.
        """
        return _optim.OptimizationSolverImplementationPointer_hasName(self)


    def hasVisibleName(self):
        """
        Test if the object has a distinguishable name.

        Returns
        -------
        hasVisibleName : bool
            True if the name is not empty and not the default one.
        """
        return _optim.OptimizationSolverImplementationPointer_hasVisibleName(self)


    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : str
            The name of the object.
        """
        return _optim.OptimizationSolverImplementationPointer_getName(self)


    def setName(self, name):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _optim.OptimizationSolverImplementationPointer_setName(self, name)

OptimizationSolverImplementationPointer_swigregister = _optim.OptimizationSolverImplementationPointer_swigregister
OptimizationSolverImplementationPointer_swigregister(OptimizationSolverImplementationPointer)

# This file is compatible with both classic and new-style classes.


